//
// Created by shushiri on 18.2.19.
//

#include <alib/set>
#include <string/LinearString.h>
#include <stringology/cover/ApproximateCoversComputation.h>
#include "ApproximateCoversComputationTest.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ApproximateCoversComputationTest, "stringology");
CPPUNIT_TEST_SUITE_REGISTRATION ( ApproximateCoversComputationTest );

void ApproximateCoversComputationTest::setUp() {
}

void ApproximateCoversComputationTest::tearDown() {
}

void ApproximateCoversComputationTest::testApproximateCoversComputation() {
    string::LinearString < char > pattern( "acacca" );
    unsigned int k = 1;

    ext::map < ext::vector < char >, unsigned > refSet;
    ext::vector < char > a1{'a', 'a'};
    ext::vector < char > a3{'a', 'c', 'a'};
    ext::vector < char > a2{'c', 'c'};
    ext::vector < char > a4{'c', 'c', 'a'};
    ext::vector < char > a5{'a', 'c', 'c', 'c'};
    ext::vector < char > a6{'a', 'c', 'a', 'a'};
    refSet.insert( std::make_pair( a1, 1 ) );
    refSet.insert( std::make_pair( a2, 1 ) );
    refSet.insert( std::make_pair( a3, 1 ) );
    refSet.insert( std::make_pair( a4, 1 ) );
    refSet.insert( std::make_pair( a5, 1 ) );
    refSet.insert( std::make_pair( a6, 1 ) );


    ext::map<ext::vector < char >, unsigned > result =
            stringology::cover::ApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result == refSet );
}

void ApproximateCoversComputationTest::testApproximateCoversComputation2() {
    string::LinearString < char > pattern( "aca" );
    unsigned int k = 1;

    ext::map < ext::vector < char >, unsigned > refSet;
    ext::vector < char > b1{'a', 'a'};
    ext::vector < char > b2{'c', 'c'};
    refSet.insert( std::make_pair( b1, 1 ) );
    refSet.insert( std::make_pair( b2, 1 ) );

    ext::map < ext::vector < char >, unsigned > result =
            stringology::cover::ApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result == refSet );
}

void ApproximateCoversComputationTest::testApproximateCoversComputation3() {
    string::LinearString < char > pattern( "abab" );
    unsigned int k = 1;


    ext::map<ext::vector < char >, unsigned > refSet;
    ext::vector < char > c1{'a', 'a'};
    ext::vector < char > c2{'a', 'b'};
    ext::vector < char > c3{'b', 'b'};
    refSet.insert( std::make_pair( c1, 1 ) );
    refSet.insert( std::make_pair( c2, 0 ) );
    refSet.insert( std::make_pair( c3, 1 ) );

    ext::map<ext::vector < char >, unsigned > result =
            stringology::cover::ApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result == refSet );
}

void ApproximateCoversComputationTest::testApproximateCoversComputation4() {
    string::LinearString < char > pattern( "" );
    unsigned int k = 1;

    ext::map < ext::vector < char >, unsigned > result =
            stringology::cover::ApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result.size() == 0 );
}

void ApproximateCoversComputationTest::testApproximateCoversComputation5() {
    string::LinearString < char > pattern ( "abab" );
    unsigned int k = 2;

    ext::map<ext::vector < char >, unsigned > refSet;
    ext::vector < char > d1 {'a', 'a', 'a'};
    ext::vector < char > d2 {'a', 'a', 'b'};
    ext::vector < char > d3 {'a', 'b', 'b'};
    ext::vector < char > d4 {'b', 'a', 'a'};
    ext::vector < char > d5 {'b', 'b', 'a'};
    ext::vector < char > d6 {'b', 'b', 'b'};
    ext::vector < char > d7 {'a', 'b'};
    ext::vector < char > d8 {'a', 'a'};
    ext::vector < char > d9 {'b', 'b'};
    refSet.insert( std::make_pair( d1, 2 ) );
    refSet.insert( std::make_pair( d2, 2 ) );
    refSet.insert( std::make_pair( d3, 2 ) );
    refSet.insert( std::make_pair( d4, 2 ) );
    refSet.insert( std::make_pair( d5, 2 ) );
    refSet.insert( std::make_pair( d6, 2 ) );
    refSet.insert( std::make_pair( d7, 0 ) );
    refSet.insert( std::make_pair( d8, 1 ) );
    refSet.insert( std::make_pair( d9, 1 ) );

    ext::map < ext::vector < char >, unsigned >  result =
            stringology::cover::ApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result == refSet );
}

