//
// Created by shushiri on 2.1.19.
//


#include <alib/set>
#include <string/LinearString.h>
#include <stringology/cover/ExactCoversComputation.h>
#include "ExactCoverComputationTest.h"


CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ExactCoverComputationTest, "stringology" );
CPPUNIT_TEST_SUITE_REGISTRATION ( ExactCoverComputationTest );

void ExactCoverComputationTest::setUp() {
}

void ExactCoverComputationTest::tearDown() {
}

void ExactCoverComputationTest::testExactCoverComputation() {
    string::LinearString < char > pattern( "atatata" );

    ext::vector < char > c{'a', 't', 'a'};
    ext::vector < char > c1{'a', 't', 'a', 't', 'a'};
    string::LinearString < char > first(c);
    string::LinearString < char > second(c1);
    ext::set<string::LinearString < char> > refSet;
    refSet.insert( first );
    refSet.insert( second );

    auto covers = stringology::cover::ExactCoversComputation::compute( pattern );

    CPPUNIT_ASSERT( refSet == covers );
}

void ExactCoverComputationTest::testExactCoverComputation2() {
    string::LinearString < char > pattern( "abaabaaabaa" );

    ext::vector < char > d{'a', 'b', 'a', 'a'};
    string::LinearString < char > first( d );
    ext::set < string::LinearString < char > > refSet;
    refSet.insert( first );

    auto covers = stringology::cover::ExactCoversComputation::compute( pattern );

    CPPUNIT_ASSERT( refSet == covers );
}

void ExactCoverComputationTest::testExactCoverComputation3() {
    string::LinearString < char > pattern( "abcdf" );

    ext::set < string::LinearString < char > > refSet;

    auto covers = stringology::cover::ExactCoversComputation::compute( pattern );

    CPPUNIT_ASSERT( refSet == covers );
}

void ExactCoverComputationTest::testExactCoverComputation4() {
    string::LinearString < char > pattern( "aaaa" );

    ext::vector < char > e{'a'};
    ext::vector < char > e1{'a', 'a'};
    ext::vector < char > e2{'a', 'a', 'a'};
    string::LinearString < char > first(e);
    string::LinearString < char > second(e1);
    string::LinearString < char > third(e2);
    ext::set < string::LinearString < char > > refSet;
    refSet.insert( first );
    refSet.insert( second );
    refSet.insert( third );

    auto covers = stringology::cover::ExactCoversComputation::compute( pattern );

    CPPUNIT_ASSERT( refSet == covers );
}

void ExactCoverComputationTest::testExactCoverComputation5() {
    string::LinearString < char > pattern ( "" );

    ext::set < string::LinearString < char > > refSet;

    auto covers = stringology::cover::ExactCoversComputation::compute( pattern );

    CPPUNIT_ASSERT( refSet == covers );
}