//
// Created by shushiri on 3.3.19.
//

#include <alib/set>
#include <string/LinearString.h>
#include "RestrictedApproximateCoversComputationTest.h"
#include <stringology/cover/RestrictedApproximateCoversComputation.h>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( RestrictedApproximateCoversComputationTest, "stringology");
CPPUNIT_TEST_SUITE_REGISTRATION ( RestrictedApproximateCoversComputationTest );

void RestrictedApproximateCoversComputationTest::setUp() {
}

void RestrictedApproximateCoversComputationTest::tearDown() {
}

void RestrictedApproximateCoversComputationTest::testRestrictedApproximateCoversComputationTest() {
    string::LinearString < char > pattern( "acacca" );
    unsigned int k = 1;

    ext::vector < char > a1{'a', 'c', 'a'};
    ext::vector < char > a2{'c', 'c'};
    ext::vector < char > a3{'c', 'c', 'a'};
    ext::map < ext::vector < char >, unsigned > refSet;
    refSet.insert( std::make_pair( a1, 1 ) );
    refSet.insert( std::make_pair( a2, 1 ) );
    refSet.insert( std::make_pair( a3, 1 ) );

    ext::map < ext::vector < char >, unsigned > result =
            stringology::cover::RestrictedApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result == refSet );
}

void RestrictedApproximateCoversComputationTest::testRestrictedApproximateCoversComputationTest2() {
    string::LinearString < char > pattern( "aca" );
    unsigned int k = 1;

    ext::map < ext::vector < char >, unsigned > result =
            stringology::cover::RestrictedApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result.size() == 0 );
}

void RestrictedApproximateCoversComputationTest::testRestrictedApproximateCoversComputationTest3() {
    string::LinearString < char > pattern ( "abab" );
    unsigned int k = 1;

    ext::vector < char > c1 {'a', 'b'};
    ext::map < ext::vector < char >, unsigned > refSet;
    refSet.insert( std::make_pair( c1, 0 ) );

    ext::map < ext::vector < char >, unsigned >  result =
            stringology::cover::RestrictedApproximateCoversComputation::compute( pattern, k );

    CPPUNIT_ASSERT( result == refSet );
}